<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: bit_hacks/bit_hacks.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_64eb892c6bd55b82613c6a491afc7b54.html">bit_hacks</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">bit_hacks.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="bit__hacks_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#ifndef BIT_HACKS_H</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#define BIT_HACKS_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">//#define BIT_HACKS_HEADER_ONLY</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#ifdef BIT_HACKS_HEADER_ONLY</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#define BIT_HACKS_SPEC static inline</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">   15</a></span>&#160;<span class="preprocessor">#define BIT_HACKS_SPEC</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="bit__hacks_8h.html#a5d5cc979bba2c75551f4a97a33b902ef">   24</a></span>&#160;<span class="preprocessor">#define U16_SET_BIT(X) ((uint16_t)1U &lt;&lt; (X))</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="bit__hacks_8h.html#a8b3535ebdbe2e88b533c69e527586e1b">   30</a></span>&#160;<span class="preprocessor">#define U32_SET_BIT(X) ((uint32_t)1 &lt;&lt; (X))</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="bit__hacks_8h.html#ad2d98dd947a531e52070a4483b20674c">   36</a></span>&#160;<span class="preprocessor">#define U64_SET_BIT(X) ((uint64_t)1 &lt;&lt; (X))</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="bit__hacks_8h.html#a044b7cf7e5a7d689dc847d052f97c7c3">   41</a></span>&#160;<span class="preprocessor">#define IS_POWER_OF_TWO(X) ((X)) &amp;&amp; (((X) &amp; ((X)-1)) == 0)</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<a class="code" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint8_t <a class="code" href="bit__hacks_8h.html#a9e5edb66844fb07c735dab608d4e775f">reverse_uint8_bits</a>(uint8_t <a class="code" href="structchunk.html#ae7f66047e6e39ba2bb6af8b95f00d1dd">value</a>);</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<a class="code" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint32_t <a class="code" href="bit__hacks_8h.html#afcfa1fe17a4acc518ca5065fb32d60dc">reverse_uint32_bits</a>(uint32_t <a class="code" href="structchunk.html#ae7f66047e6e39ba2bb6af8b95f00d1dd">value</a>);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#ifdef BIT_HACKS_HEADER_ONLY</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="bit__hacks_8c.html">bit_hacks.c</a>&quot;</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="bit__hacks_8c_html"><div class="ttname"><a href="bit__hacks_8c.html">bit_hacks.c</a></div></div>
<div class="ttc" id="bit__hacks_8h_html_a9e5edb66844fb07c735dab608d4e775f"><div class="ttname"><a href="bit__hacks_8h.html#a9e5edb66844fb07c735dab608d4e775f">reverse_uint8_bits</a></div><div class="ttdeci">BIT_HACKS_SPEC uint8_t reverse_uint8_bits(uint8_t value)</div><div class="ttdef"><b>Definition:</b> bit_hacks.c:5</div></div>
<div class="ttc" id="structchunk_html_ae7f66047e6e39ba2bb6af8b95f00d1dd"><div class="ttname"><a href="structchunk.html#ae7f66047e6e39ba2bb6af8b95f00d1dd">chunk::value</a></div><div class="ttdeci">uint32_t value</div><div class="ttdef"><b>Definition:</b> big_int.h:11</div></div>
<div class="ttc" id="bit__hacks_8h_html_afcfa1fe17a4acc518ca5065fb32d60dc"><div class="ttname"><a href="bit__hacks_8h.html#afcfa1fe17a4acc518ca5065fb32d60dc">reverse_uint32_bits</a></div><div class="ttdeci">BIT_HACKS_SPEC uint32_t reverse_uint32_bits(uint32_t value)</div><div class="ttdef"><b>Definition:</b> bit_hacks.c:20</div></div>
<div class="ttc" id="bit__hacks_8h_html_ad56990640efca96116337c655ff20984"><div class="ttname"><a href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a></div><div class="ttdeci">#define BIT_HACKS_SPEC</div><div class="ttdef"><b>Definition:</b> bit_hacks.h:15</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
